type op = Add | Sub | Mult | Mod | Div | Equal | Neq | Less | Leq | Greater | Geq 

type uop = Sqrt | Sum | Avg | Abs | Log

type variable = 
		IntVar of string
	| ArrayVar of string * int

type fparam =
		Int of string
	| Array of string

type varcall = 
		IntVarCall of string
	| ArrayVarCall of string * expr
and expr =
    Literal of int
  | Var of varcall
  | Binop of expr * op * expr
	| Uniop of uop * expr
	| Power of expr * expr
  | Assign of varcall * expr
  | Call of string * expr list
  | Noexpr

type functiontype =
		VoidRet
	| IntRet
	| ArrayRet

type stmt =
    Block of stmt list
  | Expr of expr
  | Return of expr
  | If of expr * stmt * stmt
  | For of expr * expr * expr * stmt
  | While of expr * stmt
	| Print of expr

type functiondecl = {
		ftype : functiontype;
    fname : string;
    formals : fparam list;
    locals : variable list;
    body : stmt list;
  }

type program = functiondecl list
